diff --git a/src/or/routerlist.c b/src/or/routerlist.c
index 8d25eaa..e5f43bb 100644
--- a/src/or/routerlist.c
+++ b/src/or/routerlist.c
@@ -246,10 +246,10 @@ trusted_dirs_load_certs_from_string(const char *contents, int from_store,
     if (ds && cert->cache_info.published_on > ds->addr_current_at) {
       /* Check to see whether we should update our view of the authority's
        * address. */
-      if (cert->addr && cert->dir_port &&
-          (ds->addr != cert->addr ||
+      if (tor_addr_is_null(&cert->addr) && cert->dir_port &&
+          (tor_addr_eq(&ds->addr, &cert->addr) ||
            ds->dir_port != cert->dir_port)) {
-        char *a = tor_dup_ip(cert->addr);
+        char *a = tor_dup_ip(&cert->addr);
         log_notice(LD_DIR, "Updating address for directory authority %s "
                    "from %s:%d to %s:%d based on certificate.",
                    ds->nickname, ds->address, (int)ds->dir_port,
@@ -1105,7 +1105,6 @@ router_pick_directory_server_impl(dirinfo_type_t type, int flags)
   SMARTLIST_FOREACH_BEGIN(nodelist_get_list(), const node_t *, node) {
     int is_trusted;
     int is_overloaded;
-    tor_addr_t addr;
     const routerstatus_t *status = node->rs;
     const country_t country = node->country;
     if (!status)
@@ -1140,18 +1139,21 @@ router_pick_directory_server_impl(dirinfo_type_t type, int flags)
     }
 
     /* XXXX IP6 proposal 118 */
-    tor_addr_from_ipv4h(&addr, node->rs->addr);
 
+    /* XXX-IPv6: we might want to check that the address is IPv4 and reject others
+     *           that the internal datastructures support it does not mean that the
+     *           protocol wants to carry it here
+     */
     is_overloaded = status->last_dir_503_at + DIR_503_TIMEOUT > now;
 
     if (prefer_tunnel &&
         status->version_supports_begindir &&
         (!fascistfirewall ||
-         fascist_firewall_allows_address_or(&addr, status->or_port)))
+         fascist_firewall_allows_address_or(&node->rs->addr, status->or_port)))
       smartlist_add(is_trusted ? trusted_tunnel :
                     is_overloaded ? overloaded_tunnel : tunnel, (void*)node);
     else if (!fascistfirewall ||
-             fascist_firewall_allows_address_dir(&addr, status->dir_port))
+             fascist_firewall_allows_address_dir(&node->rs->addr, status->dir_port))
       smartlist_add(is_trusted ? trusted_direct :
                     is_overloaded ? overloaded_direct : direct, (void*)node);
   } SMARTLIST_FOREACH_END(node);
@@ -1244,14 +1246,13 @@ router_pick_trusteddirserver_impl(dirinfo_type_t type, int flags,
         continue;
       }
 
-      /* XXXX IP6 proposal 118 */
-      tor_addr_from_ipv4h(&addr, d->addr);
+      /* XXXX IP6 proposal 118 (XXX-IPv6: need to check if this should be IPv4-only) */
 
       if (no_serverdesc_fetching) {
         if (connection_get_by_type_addr_port_purpose(
-            CONN_TYPE_DIR, &addr, d->dir_port, DIR_PURPOSE_FETCH_SERVERDESC)
+            CONN_TYPE_DIR, &d->addr, d->dir_port, DIR_PURPOSE_FETCH_SERVERDESC)
          || connection_get_by_type_addr_port_purpose(
-             CONN_TYPE_DIR, &addr, d->dir_port, DIR_PURPOSE_FETCH_EXTRAINFO)) {
+             CONN_TYPE_DIR, &d->addr, d->dir_port, DIR_PURPOSE_FETCH_EXTRAINFO)) {
           //log_debug(LD_DIR, "We have an existing connection to fetch "
           //           "descriptor from %s; delaying",d->description);
           ++n_busy;
@@ -1336,7 +1337,7 @@ mark_all_trusteddirservers_up(void)
 int
 routers_have_same_or_addr(const routerinfo_t *r1, const routerinfo_t *r2)
 {
-  return r1->addr == r2->addr && r1->or_port == r2->or_port;
+  return tor_addr_eq(&r1->addr, &r2->addr) && r1->or_port == r2->or_port;
 }
 
 /** Reset all internal variables used to count failed downloads of network
@@ -1354,6 +1355,7 @@ addrs_in_same_network_family(const tor_addr_t *a1,
                              const tor_addr_t *a2)
 {
   /* XXXX MOVE ? */
+  /* XXX_IPv6: Only compare a /16, should use different length for IPv6 */
   return 0 == tor_addr_compare_masked(a1, a2, 16, CMP_SEMANTIC);
 }
 
@@ -1375,13 +1377,8 @@ nodelist_add_node_family(smartlist_t *sl, const node_t *node)
 
   /* First, add any nodes with similar network addresses. */
   if (options->EnforceDistinctSubnets) {
-    tor_addr_t node_addr;
-    node_get_addr(node, &node_addr);
-
     SMARTLIST_FOREACH_BEGIN(all_nodes, const node_t *, node2) {
-      tor_addr_t a;
-      node_get_addr(node2, &a);
-      if (addrs_in_same_network_family(&a, &node_addr))
+      if (addrs_in_same_network_family(node_get_addr(node2), node_get_addr(node)))
         smartlist_add(sl, (void*)node2);
     } SMARTLIST_FOREACH_END(node2);
   }
@@ -1460,10 +1457,7 @@ nodes_in_same_family(const node_t *node1, const node_t *node2)
 
   /* Are they in the same family because of their addresses? */
   if (options->EnforceDistinctSubnets) {
-    tor_addr_t a1, a2;
-    node_get_addr(node1, &a1);
-    node_get_addr(node2, &a2);
-    if (addrs_in_same_network_family(&a1, &a2))
+    if (addrs_in_same_network_family(node_get_addr(node1), node_get_addr(node2)))
       return 1;
   }
 
@@ -1562,21 +1556,16 @@ routerlist_find_my_routerinfo(void)
 const node_t *
 router_find_exact_exit_enclave(const char *address, uint16_t port)
 {/*XXXX MOVE*/
-  uint32_t addr;
-  struct in_addr in;
-  tor_addr_t a;
+  tor_addr_t addr;
   or_options_t *options = get_options();
 
-  if (!tor_inet_aton(address, &in))
+  if (!tor_inet_pton(AF_UNSPEC, address, &addr))
     return NULL; /* it's not an IP already */
-  addr = ntohl(in.s_addr);
-
-  tor_addr_from_ipv4h(&a, addr);
 
   SMARTLIST_FOREACH(nodelist_get_list(), const node_t *, node, {
-    if (node_get_addr_ipv4h(node) == addr &&
+    if (tor_addr_eq(node_get_addr(node), &addr) &&
         node->is_running &&
-        compare_tor_addr_to_node_policy(&a, port, node) ==
+        compare_tor_addr_to_node_policy(&addr, port, node) ==
           ADDR_POLICY_ACCEPTED &&
         !routerset_contains_node(options->_ExcludeExitNodesUnion, node))
       return node;
@@ -2468,12 +2457,12 @@ router_digest_is_trusted_dir_type(const char *digest, dirinfo_type_t type)
 /** Return true iff <b>addr</b> is the address of one of our trusted
  * directory authorities. */
 int
-router_addr_is_trusted_dir(uint32_t addr)
+router_addr_is_trusted_dir(tor_addr_t *addr)
 {
   if (!trusted_dir_servers)
     return 0;
   SMARTLIST_FOREACH(trusted_dir_servers, trusted_dir_server_t *, ent,
-    if (ent->addr == addr)
+    if (tor_addr_eq(&ent->addr, addr))
       return 1;
     );
   return 0;
@@ -4017,7 +4006,7 @@ routerlist_retry_directory_downloads(time_t now)
 /** Return 1 if all running sufficiently-stable routers we can use will reject
  * addr:port, return 0 if any might accept it. */
 int
-router_exit_policy_all_nodes_reject(uint32_t addr, uint16_t port,
+router_exit_policy_all_nodes_reject(tor_addr_t *addr, uint16_t port,
                                     int need_uptime)
 { /* XXXX MOVE */
   addr_policy_result_t r;
@@ -4026,7 +4015,7 @@ router_exit_policy_all_nodes_reject(uint32_t addr, uint16_t port,
     if (node->is_running &&
         !node_is_unreliable(node, need_uptime, 0, 0)) {
 
-      r = compare_addr_to_node_policy(addr, port, node);
+      r = compare_tor_addr_to_node_policy(addr, port, node);
 
       if (r != ADDR_POLICY_REJECTED && r != ADDR_POLICY_PROBABLY_REJECTED)
         return 0; /* this one could be ok. good enough. */
@@ -4054,21 +4043,21 @@ add_trusted_dir_server(const char *nickname, const char *address,
                        dirinfo_type_t type)
 {
   trusted_dir_server_t *ent;
-  uint32_t a;
+  tor_addr_t addr;
   char *hostname = NULL;
   size_t dlen;
   if (!trusted_dir_servers)
     trusted_dir_servers = smartlist_create();
 
   if (!address) { /* The address is us; we should guess. */
-    if (resolve_my_address(LOG_WARN, get_options(), &a, &hostname) < 0) {
+    if (resolve_my_address(LOG_WARN, get_options(), &addr, &hostname) < 0) {
       log_warn(LD_CONFIG,
                "Couldn't find a suitable address when adding ourself as a "
                "trusted directory server.");
       return NULL;
     }
   } else {
-    if (tor_lookup_hostname(address, &a)) {
+    if (tor_addr_lookup(address, AF_UNSPEC, &addr)) {
       log_warn(LD_CONFIG,
                "Unable to lookup address for directory server at '%s'",
                address);
@@ -4080,7 +4069,7 @@ add_trusted_dir_server(const char *nickname, const char *address,
   ent = tor_malloc_zero(sizeof(trusted_dir_server_t));
   ent->nickname = nickname ? tor_strdup(nickname) : NULL;
   ent->address = hostname;
-  ent->addr = a;
+  tor_addr_copy(&ent->addr, &addr);
   ent->dir_port = dir_port;
   ent->or_port = or_port;
   ent->is_running = 1;
@@ -5572,7 +5561,7 @@ routerset_contains(const routerset_t *set, const tor_addr_t *addr,
     return 3;
   if (set->countries) {
     if (country < 0 && addr)
-      country = geoip_get_country_by_ip(tor_addr_to_ipv4h(addr));
+      country = geoip_get_country_by_ip(addr);
 
     if (country >= 0 && country < set->n_countries &&
         bitarray_is_set(set->countries, country))
@@ -5599,10 +5588,8 @@ int
 routerset_contains_router(const routerset_t *set, const routerinfo_t *ri,
                           country_t country)
 {
-  tor_addr_t addr;
-  tor_addr_from_ipv4h(&addr, ri->addr);
   return routerset_contains(set,
-                            &addr,
+                            &ri->addr,
                             ri->or_port,
                             ri->nickname,
                             ri->cache_info.identity_digest,
@@ -5616,10 +5603,8 @@ routerset_contains_routerstatus(const routerset_t *set,
                                 const routerstatus_t *rs,
                                 country_t country)
 {
-  tor_addr_t addr;
-  tor_addr_from_ipv4h(&addr, rs->addr);
   return routerset_contains(set,
-                            &addr,
+                            &rs->addr,
                             rs->or_port,
                             rs->nickname,
                             rs->identity_digest,
@@ -5786,9 +5771,9 @@ void
 node_set_country(node_t *node)
 {
   if (node->rs)
-    node->country = geoip_get_country_by_ip(node->rs->addr);
+    node->country = geoip_get_country_by_ip(&node->rs->addr);
   else if (node->ri)
-    node->country = geoip_get_country_by_ip(node->ri->addr);
+    node->country = geoip_get_country_by_ip(&node->ri->addr);
   else
     node->country = -1;
 }
diff --git a/src/or/routerlist.h b/src/or/routerlist.h
index a613c34..4ac9421 100644
--- a/src/or/routerlist.h
+++ b/src/or/routerlist.h
@@ -61,7 +61,7 @@ int router_digest_is_trusted_dir_type(const char *digest,
 #define router_digest_is_trusted_dir(d) \
   router_digest_is_trusted_dir_type((d), NO_DIRINFO)
 
-int router_addr_is_trusted_dir(uint32_t addr);
+int router_addr_is_trusted_dir(tor_addr_t *addr);
 int hexdigest_to_digest(const char *hexdigest, char *digest);
 const routerinfo_t *router_get_by_hexdigest(const char *hexdigest);
 const routerinfo_t *router_get_by_id_digest(const char *digest);
@@ -129,7 +129,7 @@ void router_load_extrainfo_from_string(const char *s, const char *eos,
                                        int descriptor_digests);
 
 void routerlist_retry_directory_downloads(time_t now);
-int router_exit_policy_all_nodes_reject(uint32_t addr, uint16_t port,
+int router_exit_policy_all_nodes_reject(tor_addr_t *addr, uint16_t port,
                                         int need_uptime);
 
 int router_exit_policy_rejects_all(const routerinfo_t *router);
diff --git a/src/or/routerparse.c b/src/or/routerparse.c
index 3f5aad8..62dc682 100644
--- a/src/or/routerparse.c
+++ b/src/or/routerparse.c
@@ -1278,7 +1278,6 @@ router_parse_entry_from_string(const char *s, const char *end,
   char digest[128];
   smartlist_t *tokens = NULL, *exit_policy_tokens = NULL;
   directory_token_t *tok;
-  struct in_addr in;
   const char *start_of_annotations, *cp, *s_dup = s;
   size_t prepend_len = prepend_annotations ? strlen(prepend_annotations) : 0;
   int ok = 1;
@@ -1387,11 +1386,10 @@ router_parse_entry_from_string(const char *s, const char *end,
     goto err;
   }
   router->address = tor_strdup(tok->args[1]);
-  if (!tor_inet_aton(router->address, &in)) {
+  if (!tor_inet_pton(AF_UNSPEC, router->address, &router->addr)) {
     log_warn(LD_DIR,"Router address is not an IP address.");
     goto err;
   }
-  router->addr = ntohl(in.s_addr);
 
   router->or_port =
     (uint16_t) tor_parse_long(tok->args[2],10,0,65535,&ok,NULL);
@@ -1803,18 +1801,16 @@ authority_cert_parse_from_string(const char *s, const char **end_of_string)
 
   tok = find_opt_by_keyword(tokens, K_DIR_ADDRESS);
   if (tok) {
-    struct in_addr in;
     char *address = NULL;
     tor_assert(tok->n_args);
     /* XXX023 use tor_addr_port_parse() below instead. -RD */
     if (parse_addr_port(LOG_WARN, tok->args[0], &address, NULL,
                         &cert->dir_port)<0 ||
-        tor_inet_aton(address, &in) == 0) {
+        tor_inet_pton(AF_UNSPEC, address, &cert->addr) == 0) {
       log_warn(LD_DIR, "Couldn't parse dir-address in certificate");
       tor_free(address);
       goto err;
     }
-    cert->addr = ntohl(in.s_addr);
     tor_free(address);
   }
 
@@ -1951,7 +1947,6 @@ routerstatus_parse_entry_from_string(memarea_t *area,
   routerstatus_t *rs = NULL;
   directory_token_t *tok;
   char timebuf[ISO_TIME_LEN+1];
-  struct in_addr in;
   int offset = 0;
   tor_assert(tokens);
   tor_assert(bool_eq(vote, vote_rs));
@@ -2018,12 +2013,11 @@ routerstatus_parse_entry_from_string(memarea_t *area,
     goto err;
   }
 
-  if (tor_inet_aton(tok->args[5+offset], &in) == 0) {
+  if (tor_inet_pton(AF_UNSPEC, tok->args[5+offset], &rs->addr) == 0) {
     log_warn(LD_DIR, "Error parsing router address in network-status %s",
              escaped(tok->args[5+offset]));
     goto err;
   }
-  rs->addr = ntohl(in.s_addr);
 
   rs->or_port = (uint16_t) tor_parse_long(tok->args[6+offset],
                                          10,0,65535,NULL,NULL);
@@ -2230,7 +2224,6 @@ networkstatus_v2_parse_from_string(const char *s)
   networkstatus_v2_t *ns = NULL;
   char ns_digest[DIGEST_LEN];
   char tmp_digest[DIGEST_LEN];
-  struct in_addr in;
   directory_token_t *tok;
   int i;
   memarea_t *area = NULL;
@@ -2260,12 +2253,11 @@ networkstatus_v2_parse_from_string(const char *s)
   tok = find_by_keyword(tokens, K_DIR_SOURCE);
   tor_assert(tok->n_args >= 3);
   ns->source_address = tor_strdup(tok->args[0]);
-  if (tor_inet_aton(tok->args[1], &in) == 0) {
+  if (tor_inet_pton(AF_UNSPEC, tok->args[1], &ns->source_addr) == 0) {
     log_warn(LD_DIR, "Error parsing network-status source address %s",
              escaped(tok->args[1]));
     goto err;
   }
-  ns->source_addr = ntohl(in.s_addr);
   ns->source_dirport =
     (uint16_t) tor_parse_long(tok->args[2],10,0,65535,NULL,NULL);
   if (ns->source_dirport == 0) {
@@ -2791,7 +2783,6 @@ networkstatus_parse_vote_from_string(const char *s, const char **eos_out,
   const char *cert, *end_of_header, *end_of_footer, *s_dup = s;
   directory_token_t *tok;
   int ok;
-  struct in_addr in;
   int i, inorder, n_signatures = 0;
   memarea_t *area = NULL, *rs_area = NULL;
   consensus_flavor_t flav = FLAV_NS;
@@ -3006,12 +2997,11 @@ networkstatus_parse_vote_from_string(const char *s, const char **eos_out,
         goto err;
       }
       voter->address = tor_strdup(tok->args[2]);
-      if (!tor_inet_aton(tok->args[3], &in)) {
+      if (!tor_inet_pton(AF_UNSPEC, tok->args[3], &voter->addr)) {
         log_warn(LD_DIR, "Error decoding IP address %s in network-status.",
                  escaped(tok->args[3]));
         goto err;
       }
-      voter->addr = ntohl(in.s_addr);
       voter->dir_port = (uint16_t)
         tor_parse_long(tok->args[4], 10, 0, 65535, &ok, NULL);
       if (!ok)
diff --git a/src/test/test.c b/src/test/test.c
index e2f8b11..76704de 100644
--- a/src/test/test.c
+++ b/src/test/test.c
@@ -625,19 +625,22 @@ test_policies(void)
   test_assert(p != NULL);
   test_eq(ADDR_POLICY_REJECT, p->policy_type);
   tor_addr_from_ipv4h(&tar, 0xc0a80000u);
-  test_eq(0, tor_addr_compare(&p->addr, &tar, CMP_EXACT));
+  test_assert(tor_addr_eq(&p->addr, &tar));
   test_eq(16, p->maskbits);
   test_eq(1, p->prt_min);
   test_eq(65535, p->prt_max);
 
   smartlist_add(policy, p);
 
+  tor_addr_from_ipv4h(&tar, 0x01020304u);
   test_assert(ADDR_POLICY_ACCEPTED ==
-          compare_addr_to_addr_policy(0x01020304u, 2, policy));
+          compare_tor_addr_to_addr_policy(&tar, 2, policy));
+  tor_addr_from_ipv4h(&tar, 0);
   test_assert(ADDR_POLICY_PROBABLY_ACCEPTED ==
-          compare_addr_to_addr_policy(0, 2, policy));
+          compare_tor_addr_to_addr_policy(&tar, 2, policy));
+  tor_addr_from_ipv4h(&tar, 0xc0a80102);
   test_assert(ADDR_POLICY_REJECTED ==
-          compare_addr_to_addr_policy(0xc0a80102, 2, policy));
+          compare_tor_addr_to_addr_policy(&tar, 2, policy));
 
   test_assert(0 == policies_parse_exit_policy(NULL, &policy2, 1, NULL, 1));
   test_assert(policy2);
@@ -1047,12 +1050,13 @@ static void
 test_geoip(void)
 {
   int i, j;
+  tor_addr_t addr;
   time_t now = time(NULL);
   char *s = NULL;
 
   /* Populate the DB a bit.  Add these in order, since we can't do the final
    * 'sort' step.  These aren't very good IP addresses, but they're perfectly
-   * fine uint32_t values. */
+   * fine 32-bit values. */
   test_eq(0, geoip_parse_entry("10,50,AB"));
   test_eq(0, geoip_parse_entry("52,90,XY"));
   test_eq(0, geoip_parse_entry("95,100,AB"));
@@ -1062,31 +1066,48 @@ test_geoip(void)
 
   /* We should have 4 countries: ??, ab, xy, zz. */
   test_eq(4, geoip_get_n_countries());
+
   /* Make sure that country ID actually works. */
-#define NAMEFOR(x) geoip_get_country_name(geoip_get_country_by_ip(x))
-  test_streq("??", NAMEFOR(3));
-  test_eq(0, geoip_get_country_by_ip(3));
-  test_streq("ab", NAMEFOR(32));
-  test_streq("??", NAMEFOR(5));
-  test_streq("??", NAMEFOR(51));
-  test_streq("xy", NAMEFOR(150));
-  test_streq("xy", NAMEFOR(190));
-  test_streq("??", NAMEFOR(2000));
+#define SETIP(x) tor_addr_from_ipv4n(&addr, x)
+#define NAMEFOR() geoip_get_country_name(geoip_get_country_by_ip(&addr))
+  SETIP(3);
+  test_streq("??", NAMEFOR());
+  test_eq(0, geoip_get_country_by_ip(&addr));
+  SETIP(32);
+  test_streq("ab", NAMEFOR());
+  SETIP(5);
+  test_streq("??", NAMEFOR());
+  SETIP(51);
+  test_streq("??", NAMEFOR());
+  SETIP(150);
+  test_streq("xy", NAMEFOR());
+  SETIP(190);
+  test_streq("xy", NAMEFOR());
+  SETIP(2000);
+  test_streq("??", NAMEFOR());
+#undef SETIP
 #undef NAMEFOR
 
   get_options()->BridgeRelay = 1;
   get_options()->BridgeRecordUsageByCountry = 1;
   /* Put 9 observations in AB... */
-  for (i=32; i < 40; ++i)
-    geoip_note_client_seen(GEOIP_CLIENT_CONNECT, i, now-7200);
-  geoip_note_client_seen(GEOIP_CLIENT_CONNECT, 225, now-7200);
+  for (i=32; i < 40; ++i) {
+    tor_addr_from_ipv4n(&addr, i);
+    geoip_note_client_seen(GEOIP_CLIENT_CONNECT, &addr, now-7200);
+  }
+  tor_addr_from_ipv4n(&addr, 225);
+  geoip_note_client_seen(GEOIP_CLIENT_CONNECT, &addr, now-7200);
   /* and 3 observations in XY, several times. */
   for (j=0; j < 10; ++j)
-    for (i=52; i < 55; ++i)
-      geoip_note_client_seen(GEOIP_CLIENT_CONNECT, i, now-3600);
+    for (i=52; i < 55; ++i) {
+      tor_addr_from_ipv4n(&addr, i);
+      geoip_note_client_seen(GEOIP_CLIENT_CONNECT, &addr, now-3600);
+    }
   /* and 17 observations in ZZ... */
-  for (i=110; i < 127; ++i)
-    geoip_note_client_seen(GEOIP_CLIENT_CONNECT, i, now);
+  for (i=110; i < 127; ++i) {
+    tor_addr_from_ipv4n(&addr, i);
+    geoip_note_client_seen(GEOIP_CLIENT_CONNECT, &addr, now);
+  }
   s = geoip_get_client_history(GEOIP_CLIENT_CONNECT);
   test_assert(s);
   test_streq("zz=24,ab=16,xy=8", s);
diff --git a/src/test/test_addr.c b/src/test/test_addr.c
index 6db4ee2..2a02df1 100644
--- a/src/test/test_addr.c
+++ b/src/test/test_addr.c
@@ -10,20 +10,21 @@
 static void
 test_addr_basic(void)
 {
-  uint32_t u32;
+  tor_addr_t addr;
+  tor_addr_t addr2;
   uint16_t u16;
   char *cp;
 
   /* Test parse_addr_port */
-  cp = NULL; u32 = 3; u16 = 3;
-  test_assert(!parse_addr_port(LOG_WARN, "1.2.3.4", &cp, &u32, &u16));
+  cp = NULL; u16 = 3;
+  test_assert(!parse_addr_port(LOG_WARN, "1.2.3.4", &cp, &addr, &u16));
   test_streq(cp, "1.2.3.4");
-  test_eq(u32, 0x01020304u);
+  test_eq(tor_addr_to_ipv4h(&addr), 0x01020304u);
   test_eq(u16, 0);
   tor_free(cp);
-  test_assert(!parse_addr_port(LOG_WARN, "4.3.2.1:99", &cp, &u32, &u16));
+  test_assert(!parse_addr_port(LOG_WARN, "4.3.2.1:99", &cp, &addr, &u16));
   test_streq(cp, "4.3.2.1");
-  test_eq(u32, 0x04030201u);
+  test_eq(tor_addr_to_ipv4h(&addr), 0x04030201u);
   test_eq(u16, 99);
   tor_free(cp);
   test_assert(!parse_addr_port(LOG_WARN, "nonexistent.address:4040",
@@ -31,28 +32,33 @@ test_addr_basic(void)
   test_streq(cp, "nonexistent.address");
   test_eq(u16, 4040);
   tor_free(cp);
-  test_assert(!parse_addr_port(LOG_WARN, "localhost:9999", &cp, &u32, &u16));
+  test_assert(!parse_addr_port(LOG_WARN, "localhost:9999", &cp, &addr, &u16));
   test_streq(cp, "localhost");
-  test_eq(u32, 0x7f000001u);
+  test_eq(tor_addr_to_ipv4h(&addr), 0x7f000001u);
   test_eq(u16, 9999);
   tor_free(cp);
-  u32 = 3;
-  test_assert(!parse_addr_port(LOG_WARN, "localhost", NULL, &u32, &u16));
+  test_assert(!parse_addr_port(LOG_WARN, "localhost", NULL, &addr, &u16));
   test_eq(cp, NULL);
-  test_eq(u32, 0x7f000001u);
+  tor_addr_from_ipv4h(&addr2, 0x7f000001u);
+  test_assert(tor_addr_eq(&addr, &addr2));
   test_eq(u16, 0);
   tor_free(cp);
-  test_eq(0, addr_mask_get_bits(0x0u));
-  test_eq(32, addr_mask_get_bits(0xFFFFFFFFu));
-  test_eq(16, addr_mask_get_bits(0xFFFF0000u));
-  test_eq(31, addr_mask_get_bits(0xFFFFFFFEu));
-  test_eq(1, addr_mask_get_bits(0x80000000u));
+  tor_addr_from_ipv4h(&addr, 0x0u);
+  test_eq(0, tor_addr_mask_get_bits(&addr));
+  tor_addr_from_ipv4h(&addr, 0xFFFFFFFFu);
+  test_eq(32, tor_addr_mask_get_bits(&addr));
+  tor_addr_from_ipv4h(&addr, 0xFFFF0000u);
+  test_eq(16, tor_addr_mask_get_bits(&addr));
+  tor_addr_from_ipv4h(&addr, 0xFFFFFFFEu);
+  test_eq(31, tor_addr_mask_get_bits(&addr));
+  tor_addr_from_ipv4h(&addr, 0x80000000u);
+  test_eq(1, tor_addr_mask_get_bits(&addr));
 
   /* Test inet_ntop */
   {
     char tmpbuf[TOR_ADDR_BUF_LEN];
     const char *ip = "176.192.208.224";
-    struct in_addr in;
+    struct tor_addr_t in;
     tor_inet_pton(AF_INET, ip, &in);
     tor_inet_ntop(AF_INET, &in, tmpbuf, sizeof(tmpbuf));
     test_streq(tmpbuf, ip);
@@ -104,7 +110,7 @@ test_addr_basic(void)
 /** Helper: assert that <b>a</b> parses by tor_inet_pton() into a address that
  * passes tor_addr_is_internal() with <b>for_listening</b>. */
 #define test_internal_ip(a,for_listening) STMT_BEGIN           \
-    test_eq(tor_inet_pton(AF_INET6, a, &t1.addr.in6_addr), 1); \
+    test_eq(tor_inet_pton(AF_INET6, a, &t1), 1); \
     t1.family = AF_INET6;                                      \
     if (!tor_addr_is_internal(&t1, for_listening))             \
       test_fail_msg( a "was not internal.");                   \
@@ -113,7 +119,7 @@ test_addr_basic(void)
 /** Helper: assert that <b>a</b> parses by tor_inet_pton() into a address that
  * does not pass tor_addr_is_internal() with <b>for_listening</b>. */
 #define test_external_ip(a,for_listening) STMT_BEGIN           \
-    test_eq(tor_inet_pton(AF_INET6, a, &t1.addr.in6_addr), 1); \
+    test_eq(tor_inet_pton(AF_INET6, a, &t1), 1); \
     t1.family = AF_INET6;                                      \
     if (tor_addr_is_internal(&t1, for_listening))              \
       test_fail_msg(a  "was not external.");                   \
@@ -123,8 +129,8 @@ test_addr_basic(void)
  * tor_inet_pton(), give addresses that compare in the order defined by
  * <b>op</b> with tor_addr_compare(). */
 #define test_addr_compare(a, op, b) STMT_BEGIN                    \
-    test_eq(tor_inet_pton(AF_INET6, a, &t1.addr.in6_addr), 1);    \
-    test_eq(tor_inet_pton(AF_INET6, b, &t2.addr.in6_addr), 1);    \
+    test_eq(tor_inet_pton(AF_INET6, a, &t1), 1);    \
+    test_eq(tor_inet_pton(AF_INET6, b, &t2), 1);    \
     t1.family = t2.family = AF_INET6;                             \
     r = tor_addr_compare(&t1,&t2,CMP_SEMANTIC);                   \
     if (!(r op 0))                                                \
@@ -135,8 +141,8 @@ test_addr_basic(void)
  * tor_inet_pton(), give addresses that compare in the order defined by
  * <b>op</b> with tor_addr_compare_masked() with <b>m</b> masked. */
 #define test_addr_compare_masked(a, op, b, m) STMT_BEGIN          \
-    test_eq(tor_inet_pton(AF_INET6, a, &t1.addr.in6_addr), 1);    \
-    test_eq(tor_inet_pton(AF_INET6, b, &t2.addr.in6_addr), 1);    \
+    test_eq(tor_inet_pton(AF_INET6, a, &t1), 1);    \
+    test_eq(tor_inet_pton(AF_INET6, b, &t2), 1);    \
     t1.family = t2.family = AF_INET6;                             \
     r = tor_addr_compare_masked(&t1,&t2,m,CMP_SEMANTIC);          \
     if (!(r op 0))                                                \
@@ -150,7 +156,7 @@ test_addr_basic(void)
 #define test_addr_mask_ports_parse(xx, f, ip1, ip2, ip3, ip4, mm, pt1, pt2) \
   STMT_BEGIN                                                                \
     test_eq(tor_addr_parse_mask_ports(xx, &t1, &mask, &port1, &port2), f);  \
-    p1=tor_inet_ntop(AF_INET6, &t1.addr.in6_addr, bug, sizeof(bug));        \
+    p1=tor_inet_ntop(AF_INET6, &t1, bug, sizeof(bug));        \
     test_eq(htonl(ip1), tor_addr_to_in6_addr32(&t1)[0]);            \
     test_eq(htonl(ip2), tor_addr_to_in6_addr32(&t1)[1]);            \
     test_eq(htonl(ip3), tor_addr_to_in6_addr32(&t1)[2]);            \
@@ -165,7 +171,7 @@ static void
 test_addr_ip6_helpers(void)
 {
   char buf[TOR_ADDR_BUF_LEN], bug[TOR_ADDR_BUF_LEN];
-  struct in6_addr a1, a2;
+  tor_addr_t a1, a2;
   tor_addr_t t1, t2;
   int r, i;
   uint16_t port1, port2;
@@ -189,8 +195,7 @@ test_addr_ip6_helpers(void)
 
   memset(&sa_storage, 0, sizeof(sa_storage));
   test_eq(sizeof(struct sockaddr_in),
-          tor_addr_to_sockaddr(&t1, 1234, (struct sockaddr *)&sa_storage,
-                               sizeof(sa_storage)));
+          tor_addr_to_sockaddr(&t1, 1234, &sa_storage, sizeof(sa_storage)));
   test_eq(1234, ntohs(sin->sin_port));
   test_eq(0x7f7f0102, ntohl(sin->sin_addr.s_addr));
 
@@ -201,13 +206,12 @@ test_addr_ip6_helpers(void)
   sin6->sin6_addr.s6_addr[0] = 128;
   tor_addr_from_sockaddr(&t1, (struct sockaddr *)sin6, NULL);
   test_eq(tor_addr_family(&t1), AF_INET6);
-  p1 = tor_addr_to_str(buf, &t1, sizeof(buf), 0);
+  p1 = tor_addr_to_str(&t1, buf, sizeof(buf), 0);
   test_streq(p1, "8000::");
 
   memset(&sa_storage, 0, sizeof(sa_storage));
   test_eq(sizeof(struct sockaddr_in6),
-          tor_addr_to_sockaddr(&t1, 9999, (struct sockaddr *)&sa_storage,
-                               sizeof(sa_storage)));
+          tor_addr_to_sockaddr(&t1, 9999, &sa_storage, sizeof(sa_storage)));
   test_eq(AF_INET6, sin6->sin6_family);
   test_eq(9999, ntohs(sin6->sin6_port));
   test_eq(0x80000000, ntohl(S6_ADDR32(sin6->sin6_addr)[0]));
@@ -229,7 +233,7 @@ test_addr_ip6_helpers(void)
   r = tor_inet_pton(AF_INET6,
                     "0102:0304:0506:0708:090A:0B0C:0D0E:0F10", &a1);
   test_assert(r==1);
-  for (i=0;i<16;++i) { test_eq(i+1, (int)a1.s6_addr[i]); }
+  for (i=0;i<16;++i) { test_eq(i+1, (int)a1.addr.in6_addr.s6_addr[i]); }
   /* ipv4 ending. */
   test_pton6_same("0102:0304:0506:0708:090A:0B0C:0D0E:0F10",
                   "0102:0304:0506:0708:090A:0B0C:13.14.15.16");
@@ -340,7 +344,8 @@ test_addr_ip6_helpers(void)
   test_internal_ip("::ffff:169.254.0.0", 0);
   test_internal_ip("::ffff:169.254.255.255", 0);
   test_external_ip("::ffff:169.255.0.0", 0);
-  test_assert(is_internal_IP(0x7f000001, 0));
+  tor_addr_from_ipv4n(&t1, htonl(0x7f000001));
+  test_assert(tor_addr_is_internal(&t1, 0));
 
   /* tor_addr_compare(tor_addr_t x2) */
   test_addr_compare("ffff::", ==, "ffff::0");
@@ -363,10 +368,10 @@ test_addr_ip6_helpers(void)
 
   /* Test decorated addr_to_string. */
   test_eq(AF_INET6, tor_addr_from_str(&t1, "[123:45:6789::5005:11]"));
-  p1 = tor_addr_to_str(buf, &t1, sizeof(buf), 1);
+  p1 = tor_addr_to_str(&t1, buf, sizeof(buf), 1);
   test_streq(p1, "[123:45:6789::5005:11]");
   test_eq(AF_INET, tor_addr_from_str(&t1, "18.0.0.1"));
-  p1 = tor_addr_to_str(buf, &t1, sizeof(buf), 1);
+  p1 = tor_addr_to_str(&t1, buf, sizeof(buf), 1);
   test_streq(p1, "18.0.0.1");
 
   /* Test tor_addr_parse_reverse_lookup_name */
@@ -378,13 +383,13 @@ test_addr_ip6_helpers(void)
                                          AF_UNSPEC, 1);
   test_eq(1, i);
   test_eq(tor_addr_family(&t1), AF_INET);
-  p1 = tor_addr_to_str(buf, &t1, sizeof(buf), 1);
+  p1 = tor_addr_to_str(&t1, buf, sizeof(buf), 1);
   test_streq(p1, "192.168.0.1");
   i = tor_addr_parse_reverse_lookup_name(&t1, "192.168.0.99", AF_UNSPEC, 0);
   test_eq(0, i);
   i = tor_addr_parse_reverse_lookup_name(&t1, "192.168.0.99", AF_UNSPEC, 1);
   test_eq(1, i);
-  p1 = tor_addr_to_str(buf, &t1, sizeof(buf), 1);
+  p1 = tor_addr_to_str(&t1, buf, sizeof(buf), 1);
   test_streq(p1, "192.168.0.99");
   memset(&t1, 0, sizeof(t1));
   i = tor_addr_parse_reverse_lookup_name(&t1,
@@ -393,7 +398,7 @@ test_addr_ip6_helpers(void)
                                          "ip6.ARPA",
                                          AF_UNSPEC, 0);
   test_eq(1, i);
-  p1 = tor_addr_to_str(buf, &t1, sizeof(buf), 1);
+  p1 = tor_addr_to_str(&t1, buf, sizeof(buf), 1);
   test_streq(p1, "[9dee:effe:ebe1:beef:fedc:ba98:7654:3210]");
   /* Failing cases. */
   i = tor_addr_parse_reverse_lookup_name(&t1,
